var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ViewChild, ChangeDetectorRef } from '@angular/core';
import { ColumnFormat, ColumnSort } from './column-info';
import { NgForm } from '@angular/forms';
var AtGrid = /** @class */ (function () {
    /**Конструктор*/
    function AtGrid(changeDetectorRef) {
        this.changeDetectorRef = changeDetectorRef;
        /**Данные*/
        this.data = [];
        /**Колонки*/
        this.metaData = [];
        /**Количество строк на странице*/
        this.quRowOnPage = 10;
        /**Статический режим*/
        this.staticMode = true;
        /**Текущая страница*/
        this.currentPage = 0;
        /**Текущая страница*/
        this.imageSize = 100;
        /**Имя грида для хранения лайаутов*/
        this.name = 'at-grid';
        /**Выделене какой-то позиции*/
        this.onSelect = new EventEmitter();
        /**Выделене какой-то позиции*/
        this.onLoad = new EventEmitter();
        /***/
        this.onChanged = new EventEmitter();
        /**Энум в компонет*/
        this.columnFormat = ColumnFormat;
        /**Энум в компонет*/
        this.columnSort = ColumnSort;
        /**Ширина стрелки сортировки*/
        this.arrowWidth = 0;
        /**Высота стрелки сортировки*/
        this.arrowHeight = 0;
        /**Показать порядок сортировки*/
        this.showSortOrder = false;
        this.callbackSetCellStyle = function (row, column) { };
    }
    /**Инит компонента*/
    AtGrid.prototype.ngOnInit = function () {
        var fontSize = this.getDefaultFontSize();
        this.arrowWidth = fontSize / 2;
        this.arrowHeight = fontSize;
        // Восстановить лайауты
        this.restoreLayouts();
        this.calcShowSortOrder();
    };
    /**После загрузки вьюхи*/
    AtGrid.prototype.ngAfterViewChecked = function () {
    };
    /**Выделить строку*/
    AtGrid.prototype.selectRow = function (item) {
        this.onSelect.emit(item);
    };
    /**Первая страница*/
    AtGrid.prototype.firstPage = function () {
        this.currentPage = 0;
    };
    /**Первая страница*/
    AtGrid.prototype.lastPage = function () {
        this.currentPage = this.getQuPage() - 1;
    };
    /**Первая страница*/
    AtGrid.prototype.nextPage = function () {
        if (this.currentPage < (this.getQuPage() - 1)) {
            this.currentPage++;
        }
        else {
            this.currentPage = this.getQuPage() - 1;
        }
    };
    /**Первая страница*/
    AtGrid.prototype.prevPage = function () {
        if (this.currentPage > 0) {
            this.currentPage--;
        }
        else {
            this.currentPage = 0;
        }
    };
    /**Количество страниц*/
    AtGrid.prototype.getQuPage = function () {
        var result = Math.ceil(this.applyFilter().length / this.quRowOnPage);
        if (result <= 0) {
            result = 1;
        }
        return result;
    };
    Object.defineProperty(AtGrid.prototype, "humanCurrentPage", {
        /**Номер страницы от 1*/
        get: function () {
            return this.currentPage + 1;
        },
        set: function (value) {
            if (value <= 0) {
                value = 1;
            }
            else if (value > this.getQuPage()) {
                value = this.getQuPage();
            }
            if (this.currentPage != value - 1) {
                // Изменяем страницу
                this.currentPage = value - 1;
            }
            else {
                // Просто обновить вью
                // todo
                // Пока нет времени на это :(
            }
        },
        enumerable: true,
        configurable: true
    });
    /**Наложить автофильтр*/
    AtGrid.prototype.applyFilter = function () {
        var result = [];
        for (var _i = 0, _a = this.data; _i < _a.length; _i++) {
            var item = _a[_i];
            var checkFilter = true;
            for (var _b = 0, _c = this.metaData; _b < _c.length; _b++) {
                var column = _c[_b];
                if (column.filterInfo.value !== '' && column.filterInfo.value) {
                    if (item[column.name] != null) {
                        var testString = item[column.name].toString();
                        var filterText = column.filterInfo.value;
                        // Отпиливаем первую звездочку звездочку
                        if (filterText[0] === '*') {
                            filterText = filterText.substring(1);
                        }
                        else {
                            // Текст должен начинаться с фильтра
                            filterText = '^' + filterText;
                        }
                        // Экранировать слэш
                        filterText = filterText.split('\\').join("\\\\");
                        // Экранировать скобки
                        filterText = filterText.split('(').join("\\(");
                        filterText = filterText.split(')').join("\\)");
                        // Экранировать плюс
                        filterText = filterText.split('+').join("\\+");
                        // Остальные звездочки заменяем на любые символы
                        filterText = filterText.split('*').join("[\\w\\W]+");
                        // Вопрос - это любой символ
                        filterText = filterText.split('?').join("[\\w\\W]{1}");
                        //column.filterInfo.value
                        try {
                            var pattern = new RegExp(filterText, 'i');
                            // Условие правильное
                            checkFilter = pattern.test(testString);
                        }
                        catch (error) {
                            console.error('Ошибка регулярного выражения', error);
                        }
                    }
                    else {
                        checkFilter = false;
                    }
                }
                if (!checkFilter) {
                    break;
                }
            }
            if (checkFilter) {
                result.push(item);
            }
        }
        return result;
    };
    /**Сравнить две строки*/
    AtGrid.prototype.compareColumn = function (a, b, columnInfo) {
        var fieldValueA = a[columnInfo.name];
        var fieldValueB = b[columnInfo.name];
        if (fieldValueA == null && fieldValueB == null) {
            return 0;
        }
        else if (fieldValueA == null) {
            return -1;
        }
        else if (fieldValueB == null) {
            return 1;
        }
        else {
            switch (columnInfo.columnFormat) {
                case ColumnFormat.Datetime:
                    return fieldValueA.getTime() - fieldValueB.getTime();
                case ColumnFormat.Date:
                    return fieldValueA.getTime() - fieldValueB.getTime();
                case ColumnFormat.Default:
                    return fieldValueA.localeCompare(fieldValueB);
                case ColumnFormat.Number:
                    return fieldValueA - fieldValueB;
                case ColumnFormat.Currency:
                    return fieldValueA - fieldValueB;
                case ColumnFormat.Boolean:
                    return (Number(fieldValueA)) - (Number(fieldValueB));
                default:
                    return 0;
            }
        }
    };
    /**Получить строки для страницы*/
    AtGrid.prototype.getRowForPage = function () {
        var _this = this;
        var index = 0;
        var result = [];
        for (var _i = 0, _a = this.applyFilter().sort(function (a, b) {
            for (var _i = 0, _a = _this.metaData
                .filter(function (x) { return x.columnSort !== ColumnSort.None; })
                .sort(function (a, b) { return a.columnSortNumber - b.columnSortNumber; }); _i < _a.length; _i++) {
                var col = _a[_i];
                var compareResult = _this.compareColumn(a, b, col);
                if (compareResult === 0) {
                    // Переходим к следующей колонке, данные равны
                }
                else {
                    return compareResult * (col.columnSort === ColumnSort.Desc ? -1 : 1);
                }
            }
            return 0;
        }); _i < _a.length; _i++) {
            var item = _a[_i];
            if (index >= this.currentPage * this.quRowOnPage && index < (this.currentPage + 1) * this.quRowOnPage) {
                result.push(item);
            }
            index++;
        }
        return result;
    };
    /**Фильтр изменен*/
    AtGrid.prototype.filterChanged = function (filter) {
    };
    /***/
    AtGrid.prototype.mouseOver = function (rowNum) {
        this.rowNumMouseOver = rowNum;
    };
    /***/
    AtGrid.prototype.mouseOverCell = function (cellOver) {
        this.cellOver = cellOver;
    };
    /***/
    AtGrid.prototype.getCellId = function (rowNum, colNum) {
        return "at_grid_cell_" + rowNum + "'_'" + colNum;
    };
    /**Ячейка изменена*/
    AtGrid.prototype.changedCell = function (param) {
        this.onChanged.emit(param);
    };
    /***/
    AtGrid.prototype.isAllowEdit = function (rowNum, column) {
        // && column === this.cellOver && rowNum === this.rowNumMouseOver
        return column.editable;
    };
    /***/
    AtGrid.prototype.setDatetime = function (item, column, value) {
        item[column.name] = new Date(value);
    };
    /**Получить размер шрифта по умолчанию*/
    AtGrid.prototype.getDefaultFontSize = function () {
        var who = document.createElement('div');
        who.style.cssText = 'display:inline-block; padding:0; line-height:1; position:absolute; visibility:hidden; font-size:1em';
        who.appendChild(document.createTextNode('M'));
        document.body.appendChild(who);
        var fs = who.offsetHeight;
        document.body.removeChild(who);
        return +fs;
    };
    /***/
    AtGrid.prototype.calcShowSortOrder = function () {
        this.showSortOrder = this.metaData
            .filter(function (x) { return x.columnSort !== ColumnSort.None; }).length > 1;
    };
    /**Изменить сортировку колонки*/
    AtGrid.prototype.changeSort = function (columnInfo) {
        if (columnInfo.columnFormat === ColumnFormat.Template || columnInfo.columnFormat === ColumnFormat.Picture) {
            // По этим колонкам сортировать нельзя :)
            return;
        }
        if (columnInfo.allowSort) {
            if (columnInfo.columnSort === ColumnSort.None) {
                // Номер колонки для сортировки
                var columnSortNumber = 1;
                for (var _i = 0, _a = this.metaData; _i < _a.length; _i++) {
                    var col = _a[_i];
                    if (col.columnSort !== ColumnSort.None) {
                        columnSortNumber++;
                    }
                }
                columnInfo.columnSort = ColumnSort.Ask;
                columnInfo.columnSortNumber = columnSortNumber;
                console.log(columnInfo);
            }
            else if (columnInfo.columnSort === ColumnSort.Ask) {
                columnInfo.columnSort = ColumnSort.Desc;
            }
            else if (columnInfo.columnSort === ColumnSort.Desc) {
                columnInfo.columnSort = ColumnSort.None;
                columnInfo.columnSortNumber = 0;
                // Пересортировываем порядок сортировок :)
                var i = 1;
                for (var _b = 0, _c = this.metaData
                    .filter(function (x) { return x.columnSort !== ColumnSort.None; })
                    .sort(function (a, b) { return a.columnSortNumber - b.columnSortNumber; }); _b < _c.length; _b++) {
                    var col = _c[_b];
                    if (col.columnSort !== ColumnSort.None) {
                        col.columnSortNumber = i++;
                    }
                }
            }
            this.calcShowSortOrder();
            this.saveLayouts();
        }
    };
    /***/
    AtGrid.prototype.getOutGridName = function () {
        return "AtGridLayouts-" + this.name;
    };
    /***/
    AtGrid.prototype.saveLayouts = function () {
        var data = JSON.stringify(this.metaData);
        localStorage.setItem(this.getOutGridName(), data);
    };
    /***/
    AtGrid.prototype.restoreLayouts = function () {
        if (localStorage.getItem(this.getOutGridName()) != null) {
            var data = JSON.parse(localStorage.getItem(this.getOutGridName()));
            var _loop_1 = function (di) {
                var someCols = this_1.metaData.filter(function (x) { return x.name === di.name; });
                if (someCols.length > 0) {
                    var someCol = someCols[0];
                    if (di.columnSort !== ColumnSort.None) {
                        someCol.columnSort = di.columnSort;
                        someCol.columnSortNumber = di.columnSortNumber;
                    }
                }
            };
            var this_1 = this;
            for (var _i = 0, data_1 = data; _i < data_1.length; _i++) {
                var di = data_1[_i];
                _loop_1(di);
            }
        }
    };
    /***/
    AtGrid.prototype.setValue = function (item, columnName, value) {
        console.log(value);
        item[columnName] = value;
    };
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], AtGrid.prototype, "data", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], AtGrid.prototype, "metaData", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], AtGrid.prototype, "quRowOnPage", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], AtGrid.prototype, "staticMode", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], AtGrid.prototype, "currentPage", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], AtGrid.prototype, "imageSize", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Function)
    ], AtGrid.prototype, "callbackSetCellStyle", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], AtGrid.prototype, "name", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], AtGrid.prototype, "onSelect", void 0);
    __decorate([
        ViewChild('myForm'),
        __metadata("design:type", NgForm)
    ], AtGrid.prototype, "form", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], AtGrid.prototype, "onLoad", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], AtGrid.prototype, "onChanged", void 0);
    AtGrid = __decorate([
        Component({
            moduleId: module.id,
            selector: 'at-grid',
            styles: ["\n    .uneven_row{background-color:#fcfcfc}.even_row{background-color:#ffffff}.uneven_row_mouse_over{background-color:#f9f9f9}.even_row_mouse_over{background-color:#f9f9f9}.base_row_tr{cursor:pointer}.base_header_tr{cursor:pointer}.base_header_td{padding:10px}input,select{width:100%}li{padding-left:200px}td.last{width:1px;white-space:nowrap}.at-table{border-radius:10px}.even_row_input{background-color:#fafcff}.uneven_row_input{background-color:#f1f4f6}.even_row_mouse_over_input{background-color:#eeeff0}.uneven_row_mouse_over_input{background-color:#eeeff0}.common_input{border:none}.common_input::-webkit-inner-spin-button{-webkit-appearance:none}.common_input::-webkit-outer-spin-button{-webkit-appearance:none}.cell_content{height:100% !important;padding:6px;display:flex;align-items:center}.checkbox_input{max-height:1.5rem;min-height:1.5rem}.num_input,.currency_input{text-align:right}.num_view{flex-direction:row-reverse}.currency_view{flex-direction:row-reverse}.input-current-page{max-width:50px}\n  "],
            template: "\n    <form name=\"form\" id=\"form\" #myForm=\"ngForm\">\n        <button (click)=\"firstPage()\" type=\"button\"> << </button>\n        <button (click)=\"prevPage()\" type=\"button\"> < </button>\n        <input type=\"number\" name=\"currentPage\" class=\"input-current-page\" id=\"currentPage\" [(ngModel)]=\"humanCurrentPage\"> \u0438\u0437 {{getQuPage()}}\n        <button (click)=\"nextPage()\" type=\"button\"> > </button>\n        <button (click)=\"lastPage()\" type=\"button\"> >> </button>\n        <table width=\"100%\" style=\"width:100%\" border=\"1\" class=\"at-table\">\n            <thead>\n                <tr class=\"base_header_tr\">\n                    <td *ngFor=\"let column of metaData\"\n                        class=\"base_header_td\">\n                        <div style=\"display: flex; width: 100%\" (click)=\"changeSort(column)\">\n                            <div style=\"flex: auto;\"><b>{{column.comment}}</b></div>\n                            <div style=\"margin-left: 5px;\" [ngStyle] = \"{'max-width': arrowWidth + 'px', flex: 'auto'}\"><!---->\n                                <svg *ngIf = \"column.columnSort === columnSort.Desc\" [attr.height] = \"arrowHeight\" [attr.width] = \"arrowWidth\">\n                                    <line [attr.x1]=\"0\"\n                                          [attr.y1]=\"arrowHeight / 4\"\n                                          [attr.x2]=\"arrowWidth / 2\"\n                                          [attr.y2]=\"arrowHeight * 3 / 4\"\n                                          fill=\"none\" stroke=\"black\" stroke-width=\"1px\" stroke-opacity=\"1\"/>\n                                    <line [attr.x1]=\"arrowWidth / 2\"\n                                          [attr.y1]=\"arrowHeight * 3 / 4\"\n                                          [attr.x2]=\"arrowWidth\"\n                                          [attr.y2]=\"arrowHeight / 4\"\n                                          fill=\"none\" stroke=\"black\" stroke-width=\"1px\" stroke-opacity=\"1\"/>\n                                    <!--<line [attr.x1]=\"arrowWidth / 2\"-->\n                                          <!--[attr.y1]=\"0\"-->\n                                          <!--[attr.x2]=\"arrowWidth / 2\"-->\n                                          <!--[attr.y2]=\"arrowHeight\"-->\n                                          <!--fill=\"none\" stroke=\"black\" stroke-width=\"1px\" stroke-opacity=\"1\"/>-->\n                                </svg>\n                                <svg *ngIf = \"column.columnSort === columnSort.Ask\" [attr.height] = \"arrowHeight\" [attr.width] = \"arrowWidth\">\n                                    <line [attr.x1]=\"0\"\n                                          [attr.y1]=\"arrowHeight * 3 / 4\"\n                                          [attr.x2]=\"arrowWidth / 2\"\n                                          [attr.y2]=\"arrowHeight / 4\"\n                                          fill=\"none\" stroke=\"black\" stroke-width=\"1px\" stroke-opacity=\"1\"/>\n                                    <line [attr.x1]=\"arrowWidth / 2\"\n                                          [attr.y1]=\"arrowHeight / 4\"\n                                          [attr.x2]=\"arrowWidth\"\n                                          [attr.y2]=\"arrowHeight *3 / 4\"\n                                          fill=\"none\" stroke=\"black\" stroke-width=\"1px\" stroke-opacity=\"1\"/>\n                                    <!--<line [attr.x1]=\"arrowWidth / 2\"-->\n                                          <!--[attr.y1]=\"0\"-->\n                                          <!--[attr.x2]=\"arrowWidth / 2\"-->\n                                          <!--[attr.y2]=\"arrowHeight\"-->\n                                          <!--fill=\"none\" stroke=\"black\" stroke-width=\"1px\" stroke-opacity=\"1\"/>-->\n                                </svg>\n\n                            </div>\n                            <div *ngIf=\"this.showSortOrder && column.columnSort !== columnSort.None\"\n                                    [ngStyle] = \"{'max-width': arrowWidth + 'px', flex: 'auto'}\">\n                                {{column.columnSortNumber}}\n                            </div>\n                        </div>\n                    </td>\n                </tr>\n                <tr>\n                    <td *ngFor=\"let column of metaData\">\n                        <input\n                                type=\"text\"\n                                [name]=\"column.name\"\n                                [id]=\"column.name\"\n                                [(ngModel)]=\"column.filterInfo.value\"\n                                (ngModelChange)=\"filterChanged($event)\"/>\n                    </td>\n                </tr>\n            </thead>\n            <tbody>\n                <tr *ngFor=\"let item of getRowForPage(); let idx = index\"\n                    [ngClass]=\"{ 'even_row': (idx % 2 == 0) && rowNumMouseOver != idx,\n                        'uneven_row': (idx % 2 == 1) && rowNumMouseOver != idx,\n                        'even_row_mouse_over': (idx % 2 == 0) && rowNumMouseOver == idx,\n                        'uneven_row_mouse_over': (idx % 2 == 1) && rowNumMouseOver == idx\n                    }\"\n                    class=\"base_row_tr\"\n                    (click)=\"selectRow(item)\"\n                    (mouseleave)=\"mouseOver(null)\"\n                    (mouseover)=\"mouseOver(idx)\"\n                >\n                    <td *ngFor=\"let column of metaData; let colNum = index\"\n                        style = \"height: 1px;\"\n                        class=\"base_row_td\" [ngStyle] = \"callbackSetCellStyle(item, column)\"\n                        (mouseleave)=\"mouseOverCell(null)\"\n                        (mouseover)=\"mouseOverCell(column)\"\n                    >\n\n                        <div *ngIf=\"column.columnFormat == columnFormat.Number && !isAllowEdit(idx, column)\" align=\"right\"\n                             [id]=\"getCellId(idx, colNum)\"\n                             class=\"cell_content num_view\">\n                            {{item[column.name]|number}}\n                        </div>\n                        <div *ngIf=\"column.columnFormat == columnFormat.Number && isAllowEdit(idx, column)\" align=\"right\"\n                             [id]=\"getCellId(idx, colNum)\"  style=\"height: 100%\">\n                            <input type=\"number\"  pattern=\"^[-+]?[0-9]*[.,]?[0-9]+(?:[eE][-+]?[0-9]+)?$\"\n                                   [name]=\"'input' + getCellId(idx, colNum)\" [id]=\"'input' + getCellId(idx, colNum)\"\n                                   class=\"cell_content common_input num_input\"\n                                   [ngClass]=\"{ 'even_row_input': (idx % 2 == 0) && rowNumMouseOver != idx,\n                                                'uneven_row_input': (idx % 2 == 1) && rowNumMouseOver != idx,\n                                                'even_row_mouse_over_input': (idx % 2 == 0) && rowNumMouseOver == idx,\n                                                'uneven_row_mouse_over_input': (idx % 2 == 1) && rowNumMouseOver == idx\n                                                }\"\n                                   [(ngModel)]=\"item[column.name]\"\n                                   (change)=\"changedCell({columnInfo: column, value: item})\"\n                                   (click)=\"$event.stopPropagation()\"\n                            />\n                        </div>\n\n                        <div *ngIf=\"column.columnFormat == columnFormat.Currency && !isAllowEdit(idx, column)\" align=\"right\"\n                             [id]=\"getCellId(idx, colNum)\"\n                             class=\"cell_content currency_view\"\n                        >\n                            {{item[column.name]|number:'1.2-2'}}\n                        </div>\n                        <div *ngIf=\"column.columnFormat == columnFormat.Currency && isAllowEdit(idx, column)\" align=\"right\"\n                             [id]=\"getCellId(idx, colNum)\" style=\"height: 100%\">\n                            <input type=\"number\"  pattern=\"^[-+]?[0-9]*[.,]?[0-9]+(?:[eE][-+]?[0-9]+)?$\"\n                                   [name]=\"'input' + getCellId(idx, colNum)\" [id]=\"'input' + getCellId(idx, colNum)\"\n                                   class=\"cell_content common_input currency_input\"\n                                   [ngClass]=\"{ 'even_row_input': (idx % 2 == 0) && rowNumMouseOver != idx,\n                                                'uneven_row_input': (idx % 2 == 1) && rowNumMouseOver != idx,\n                                                'even_row_mouse_over_input': (idx % 2 == 0) && rowNumMouseOver == idx,\n                                                'uneven_row_mouse_over_input': (idx % 2 == 1) && rowNumMouseOver == idx\n                                                }\"\n                                   [(ngModel)]=\"item[column.name]\"\n                                   (change)=\"changedCell({columnInfo: column, value: item})\"\n                                   (click)=\"$event.stopPropagation()\"\n                            />\n                        </div>\n\n                        <div *ngIf=\"column.columnFormat == columnFormat.Date && !isAllowEdit(idx, column)\"\n                             [id]=\"getCellId(idx, colNum)\"\n                             class=\"cell_content\"\n                        >\n                            {{item[column.name]|date:'dd.MM.yyyy'}}\n                        </div>\n                        <div *ngIf=\"column.columnFormat == columnFormat.Date && isAllowEdit(idx, column)\"\n                             [id]=\"getCellId(idx, colNum)\" style=\"height: 100%\"\n                             (click)=\"$event.stopPropagation()\">\n                            <input type=\"date\"  [name]=\"'input' + getCellId(idx, colNum)\"\n                                   [id]=\"'input' + getCellId(idx, colNum)\"\n                                   class=\"cell_content common_input\"\n                                   [ngClass]=\"{ 'even_row_input': (idx % 2 == 0) && rowNumMouseOver != idx,\n                                                'uneven_row_input': (idx % 2 == 1) && rowNumMouseOver != idx,\n                                                'even_row_mouse_over_input': (idx % 2 == 0) && rowNumMouseOver == idx,\n                                                'uneven_row_mouse_over_input': (idx % 2 == 1) && rowNumMouseOver == idx\n                                                }\"\n                                   [ngModel]=\"item[column.name] | date:'yyyy-MM-dd'\"\n                                   (ngModelChange)=\"item[column.name] = $event\"\n                                   (change)=\"changedCell({columnInfo: column, value: item})\"\n                                   (click)=\"$event.stopPropagation()\"\n                            />\n                        </div>\n\n                        <div *ngIf=\"column.columnFormat == columnFormat.Datetime && !isAllowEdit(idx, column)\"\n                             [id]=\"getCellId(idx, colNum)\"\n                             class=\"cell_content\"\n                        >\n                            {{item[column.name]|date:'dd.MM.yyyy HH:mm'}}\n                        </div>\n                        <div *ngIf=\"column.columnFormat == columnFormat.Datetime && isAllowEdit(idx, column)\"\n                             [id]=\"getCellId(idx, colNum)\" style=\"height: 100%\"\n                             (click)=\"$event.stopPropagation()\">\n                            <input type=\"datetime-local\"  [name]=\"'input' + getCellId(idx, colNum)\"\n                                   [id]=\"'input' + getCellId(idx, colNum)\"\n                                   class=\"cell_content common_input\"\n                                   [ngClass]=\"{ 'even_row_input': (idx % 2 == 0) && rowNumMouseOver != idx,\n                                                'uneven_row_input': (idx % 2 == 1) && rowNumMouseOver != idx,\n                                                'even_row_mouse_over_input': (idx % 2 == 0) && rowNumMouseOver == idx,\n                                                'uneven_row_mouse_over_input': (idx % 2 == 1) && rowNumMouseOver == idx\n                                                }\"\n                                   [ngModel]=\"item[column.name] | date:'yyyy-MM-ddTHH:mm'\"\n                                   (ngModelChange)=\"setDatetime(item, column, $event)\"\n                                   (change)=\"changedCell({columnInfo: column, value: item})\"\n                                   (click)=\"$event.stopPropagation()\"\n                            />\n                        </div>\n\n                        <div *ngIf=\"column.columnFormat == columnFormat.Default && !isAllowEdit(idx, column)\"\n                             [id]=\"getCellId(idx, colNum)\"\n                             class=\"cell_content\"\n                        >\n                            {{item[column.name]}}\n                        </div>\n                        <div *ngIf=\"column.columnFormat == columnFormat.Default && isAllowEdit(idx, column)\"\n                             [id]=\"getCellId(idx, colNum)\"\n                             style=\"height: 100%\">\n                            <input type=\"text\"  [name]=\"'input' + getCellId(idx, colNum)\"\n                                   [id]=\"'input' + getCellId(idx, colNum)\"\n                                   class=\"cell_content common_input\"\n                                   [ngClass]=\"{ 'even_row_input': (idx % 2 == 0) && rowNumMouseOver != idx,\n                                                'uneven_row_input': (idx % 2 == 1) && rowNumMouseOver != idx,\n                                                'even_row_mouse_over_input': (idx % 2 == 0) && rowNumMouseOver == idx,\n                                                'uneven_row_mouse_over_input': (idx % 2 == 1) && rowNumMouseOver == idx\n                                                }\"\n                                    [value]=\"item[column.name]\"\n                                    (input)=\"setValue(item, column.name, $event.target.value)\"\n                                   (change)=\"changedCell({columnInfo: column, value: item})\"\n                                   (click)=\"$event.stopPropagation()\"\n                            />\n                        </div>\n                        <!-- [(ngModel)]=\"item[column.name]\" -->\n\n                        <div *ngIf=\"column.columnFormat == columnFormat.Boolean\"\n                             [id]=\"getCellId(idx, colNum)\"\n                             class=\"cell_content\">\n                            <input type=\"checkbox\"\n                                   [id]=\"'col_' + column.name + '_' + idx\" [name]=\"'col_' + column.name + '_' + idx\"\n                                   class=\"cell_content common_input checkbox_input\"\n                                   [ngClass]=\"{ 'even_row_input': (idx % 2 == 0) && rowNumMouseOver != idx,\n                                                'uneven_row_input': (idx % 2 == 1) && rowNumMouseOver != idx,\n                                                'even_row_mouse_over_input': (idx % 2 == 0) && rowNumMouseOver == idx,\n                                                'uneven_row_mouse_over_input': (idx % 2 == 1) && rowNumMouseOver == idx\n                                                }\"\n                                   [(ngModel)]=\"item[column.name]\"\n                                   (change)=\"changedCell({columnInfo: column, value: item})\"\n                            />\n                        </div>\n\n                        <div *ngIf=\"column.columnFormat == columnFormat.Picture && item[column.name] != null\"\n                             [id]=\"getCellId(idx, colNum)\"\n                             class=\"cell_content\">\n                            <img [width]=\"imageSize\" [height]=\"imageSize\" [src]=\"item[column.name] | safeHtml\" />\n                        </div>\n\n                        <div *ngIf=\"column.columnFormat == columnFormat.Template && item[column.name] != null\"\n                             [id]=\"getCellId(idx, colNum)\"\n                             class=\"cell_content\"\n                        >\n                            <ng-container *ngTemplateOutlet=\"item[column.name].template;context:item[column.name].context\"></ng-container>\n                        </div>\n                    </td>\n                </tr>\n            </tbody>\n        </table>\n    </form>\n  "
        }),
        __metadata("design:paramtypes", [ChangeDetectorRef])
    ], AtGrid);
    return AtGrid;
}());
export { AtGrid };
//# sourceMappingURL=at-grid.js.map